require("mineunit")

mineunit("core")
mineunit("player")
mineunit("default/functions")

sourcefile("spec/common")
sourcefile("init")

describe("get_schemapart_offset test", function()
	it("returns the proper coordinates", function()
		local offset = blockexchange.get_schemapart_offset({x=10,y=10,z=10}, {x=10,y=10,z=10})
		assert.not_nil(offset)
		assert.equal(0, offset.x)
		assert.equal(0, offset.y)
		assert.equal(0, offset.z)

		offset = blockexchange.get_schemapart_offset({x=10,y=10,z=10}, {x=11,y=11,z=11})
		assert.not_nil(offset)
		assert.equal(0, offset.x)
		assert.equal(0, offset.y)
		assert.equal(0, offset.z)

		offset = blockexchange.get_schemapart_offset({x=1000,y=10,z=10}, {x=1011,y=11,z=11})
		assert.not_nil(offset)
		assert.equal(0, offset.x)
		assert.equal(0, offset.y)
		assert.equal(0, offset.z)

		offset = blockexchange.get_schemapart_offset({x=1000,y=10,z=10}, {x=1016,y=11,z=11})
		assert.not_nil(offset)
		assert.equal(1, offset.x)
		assert.equal(0, offset.y)
		assert.equal(0, offset.z)
	end)
	it("returns the proper negative coordinates", function()
		local offset = blockexchange.get_schemapart_offset({x=10,y=10,z=10}, {x=9,y=9,z=9})
		assert.not_nil(offset)
		assert.equal(-1, offset.x)
		assert.equal(-1, offset.y)
		assert.equal(-1, offset.z)
	end)
end)
